#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include "system.h"
#include "altera_avalon_pio_regs.h"
#include <stdlib.h>

#define LED_DELAY 1000000
#define CH_BUF_SIZE (MEM_DDR3_SPAN / 32)

// Simple test to verify if external memory is working well
void mem_test(void)
{
	printf("MEM TEST START\n");
	unsigned int* mem_ptr = (unsigned int *)MEM_DDR3_BASE;
	int i;
	for(i=0; i<CH_BUF_SIZE*2;i++)
	{
		mem_ptr[i] = i+1;
	}
	printf("CHECKING..\n");
	for(i=0; i<CH_BUF_SIZE*2;i++)
	{
		if(	mem_ptr[i] != i+1)
			printf("MEM FAILURE AT %d\n", i);
	}
	printf("MEM TEST END\n");
}

void delay(int cycles)
{
	int i;
	for(i=0; i<cycles; i++)
	{
		asm("nop");
	}
}

int main()
{
	mem_test();
	while(1)
	{
		IOWR_8DIRECT(PIO_LED_BASE, 0, 0xAA);
		delay(LED_DELAY);
		IOWR_8DIRECT(PIO_LED_BASE, 0, 0x55);
		delay(LED_DELAY);
	}
	return 0;
}
