	component system is
		port (
			clk_24_clk       : in    std_logic                     := 'X';             -- clk
			clk_50_clk       : in    std_logic                     := 'X';             -- clk
			ddr3_mem_a       : out   std_logic_vector(12 downto 0);                    -- mem_a
			ddr3_mem_ba      : out   std_logic_vector(2 downto 0);                     -- mem_ba
			ddr3_mem_ck      : out   std_logic_vector(0 downto 0);                     -- mem_ck
			ddr3_mem_ck_n    : out   std_logic_vector(0 downto 0);                     -- mem_ck_n
			ddr3_mem_cke     : out   std_logic_vector(0 downto 0);                     -- mem_cke
			ddr3_mem_cs_n    : out   std_logic_vector(0 downto 0);                     -- mem_cs_n
			ddr3_mem_dm      : out   std_logic_vector(1 downto 0);                     -- mem_dm
			ddr3_mem_ras_n   : out   std_logic_vector(0 downto 0);                     -- mem_ras_n
			ddr3_mem_cas_n   : out   std_logic_vector(0 downto 0);                     -- mem_cas_n
			ddr3_mem_we_n    : out   std_logic_vector(0 downto 0);                     -- mem_we_n
			ddr3_mem_reset_n : out   std_logic;                                        -- mem_reset_n
			ddr3_mem_dq      : inout std_logic_vector(15 downto 0) := (others => 'X'); -- mem_dq
			ddr3_mem_dqs     : inout std_logic_vector(1 downto 0)  := (others => 'X'); -- mem_dqs
			ddr3_mem_dqs_n   : inout std_logic_vector(1 downto 0)  := (others => 'X'); -- mem_dqs_n
			ddr3_mem_odt     : out   std_logic_vector(0 downto 0);                     -- mem_odt
			ddr3_oct_rzqin   : in    std_logic                     := 'X';             -- rzqin
			key_export       : in    std_logic_vector(1 downto 0)  := (others => 'X'); -- export
			led_export       : out   std_logic_vector(7 downto 0);                     -- export
			reset_reset_n    : in    std_logic                     := 'X';             -- reset_n
			switch_export    : in    std_logic_vector(3 downto 0)  := (others => 'X')  -- export
		);
	end component system;

	u0 : component system
		port map (
			clk_24_clk       => CONNECTED_TO_clk_24_clk,       --   clk_24.clk
			clk_50_clk       => CONNECTED_TO_clk_50_clk,       --   clk_50.clk
			ddr3_mem_a       => CONNECTED_TO_ddr3_mem_a,       --     ddr3.mem_a
			ddr3_mem_ba      => CONNECTED_TO_ddr3_mem_ba,      --         .mem_ba
			ddr3_mem_ck      => CONNECTED_TO_ddr3_mem_ck,      --         .mem_ck
			ddr3_mem_ck_n    => CONNECTED_TO_ddr3_mem_ck_n,    --         .mem_ck_n
			ddr3_mem_cke     => CONNECTED_TO_ddr3_mem_cke,     --         .mem_cke
			ddr3_mem_cs_n    => CONNECTED_TO_ddr3_mem_cs_n,    --         .mem_cs_n
			ddr3_mem_dm      => CONNECTED_TO_ddr3_mem_dm,      --         .mem_dm
			ddr3_mem_ras_n   => CONNECTED_TO_ddr3_mem_ras_n,   --         .mem_ras_n
			ddr3_mem_cas_n   => CONNECTED_TO_ddr3_mem_cas_n,   --         .mem_cas_n
			ddr3_mem_we_n    => CONNECTED_TO_ddr3_mem_we_n,    --         .mem_we_n
			ddr3_mem_reset_n => CONNECTED_TO_ddr3_mem_reset_n, --         .mem_reset_n
			ddr3_mem_dq      => CONNECTED_TO_ddr3_mem_dq,      --         .mem_dq
			ddr3_mem_dqs     => CONNECTED_TO_ddr3_mem_dqs,     --         .mem_dqs
			ddr3_mem_dqs_n   => CONNECTED_TO_ddr3_mem_dqs_n,   --         .mem_dqs_n
			ddr3_mem_odt     => CONNECTED_TO_ddr3_mem_odt,     --         .mem_odt
			ddr3_oct_rzqin   => CONNECTED_TO_ddr3_oct_rzqin,   -- ddr3_oct.rzqin
			key_export       => CONNECTED_TO_key_export,       --      key.export
			led_export       => CONNECTED_TO_led_export,       --      led.export
			reset_reset_n    => CONNECTED_TO_reset_reset_n,    --    reset.reset_n
			switch_export    => CONNECTED_TO_switch_export     --   switch.export
		);

